// definition of Cell class
class Cell{
public:
	float latitude;	// latitude of the grid center (second)
	float longitude;	// longitude of the grid center (second)
	float dem;		// elevation [m] 
	int dir;		// flow direction
					// NN --> 1, NE --> 2, EE --> 3, SE --> 4, SS --> 5, SW-->6, WW-->7, NW-->,8
					// river mouth --> 0, sea or pit --> -1
	int distanceFromMouth;		// distance from the mouth ͌̋ 
	int sizeOfBasin;			// number of upper grids 㗬Obh̐
	int riverNumber;			// catchment number ԍ
	float longitudinalLength;	// length of 1 sec latitude ox 1 b̒ [m] 
	class Cell* neighborGrid[8]; // neighbor grid 1-->NN, 2-->NE, 3-->EE, 4-->SE, 5->SS, 6-->SW, 7-->WW, 8-->NW
	class Cell* upStreamGrid[7]; // upstream grid 㗬Obh
	class Cell* downStreamGrid;  // lowerstream grid Obh
	
	void setInit(class Cell** cell2, int i, int j);
	void setGridInfo(int irow, int icol, float iDem, int iDir, float lat, float lon, int nRow, int nCol);
	void setTmpRiverMouth(int irow, int icol, int nRow, int nCol); // temporally setting mouth
	void setRiverMouth(); // setting river mouth
	void setDownStreamGrid();
	void setUpStreamGrid();
	void setDistanceFromMouth();
	void setSizeOfBasin();
	void setRiverNumber();
};


